﻿using System;
using System.Threading;
using Microsoft.SPOT;
using Microsoft.SPOT.Hardware;
using SecretLabs.NETMF.Hardware;
using SecretLabs.NETMF.Hardware.NetduinoPlus;

using ToolBoxes;

namespace miniserreV2
{
    public class Program
    {
        public static void Main()
        {
           // Constantes
            const UInt16 delayMes = 1000;   // En ms
            const UInt16 TemperatureConsigne = 26; // En °C
            const UInt16 HumiditeSeuil = 30; // En %

            // Déclaration des variables
            var N1 = 0; // Sortie du CAN. Image de la température
            var N2 = 0; // Sortie du CAN. Image de l'humidité
            var Temperature = 0.0;
            var Humidite = 0.0;

            // Configuration des Ports d'entrées, sorties
            // Entrées analogiques
            // http://msdn.microsoft.com/en-us/library/hh421132.aspx (Description de la classe AnalogInput)
            AnalogInput Thermometre = new AnalogInput(Cpu.AnalogChannel.ANALOG_5); // Thermomètre sur I5 Tinkerkit 
            // A compléter

            // Sorties
            PWM Alarme = new PWM(PWMChannels.PWM_PIN_D5, 2000, 0.5, false); // Buzzer sur O4 Tinkerkit
            OutputPort CdeChauffage = new OutputPort(Pins.GPIO_PIN_D6, false); // Chauffage sur O3 Tinkerkit
            // A compléter
            // http://webge.github.io/ELCD162/ (Description de la classe ELCD162) 
            ELCD162 Lcd = new ELCD162(); // Afficheur sur O5 Tinkerkit

            Lcd.Init(); Lcd.ClearScreen(); Lcd.CursorOff();

            while (true)
            {
                // Lire
                N1 = Thermometre.ReadRaw(); Temperature = 0.02 * N1 - 25;
                // A compléter

                // Traiter
                if (Temperature > 26)
                    CdeChauffage.Write(false);
                else
                    CdeChauffage.Write(true);

                // A compléter




                if ((Temperature > 24) && (Temperature < 28))
                    Alarme.Stop();     
                else
                    Alarme.Start();

                // Ecrire sur le LCD
                Lcd.ClearScreen();
                Lcd.PutString("T=" + Temperature.ToString("F1") + "dC");
                // A compléter



                Thread.Sleep(delayMes); // Temporisation entre deux mesures
            }

        }

    }
}
