﻿using System;
using System.Net;
using System.Net.Sockets;
using System.Threading;
using Microsoft.SPOT;
using Microsoft.SPOT.Hardware;
using SecretLabs.NETMF.Hardware;
using SecretLabs.NETMF.Hardware.NetduinoPlus;

using ToolBoxes;

namespace miniserrefinal
{
    public partial class Program
    {
        // Modes de fonctionnement (1)
            enum etats { Attendre, Tester, Superviser }; 

        public static void Main()
        {
            // Constantes
            const UInt16 delayScrut = 100; // Le clavier est lu toutes les 100ms

            // Variables (2)
            var etat = etats.Attendre;
            var etat_1 = etats.Tester;

            // Configuration des Ports d'entrées, sorties  
            // Entrées analogiques
            // http://msdn.microsoft.com/en-us/library/hh421132.aspx (Description de la classe AnalogInput)
            AnalogInput Thermometre = new AnalogInput(Cpu.AnalogChannel.ANALOG_5); // Thermomètre sur I5 Tinkerkit 
            AnalogInput CaptHum = new AnalogInput(Cpu.AnalogChannel.ANALOG_4); // Capteur humidité sur I4 Tinkerkit
            // Entrées TOR (Clavier)
            // A compléter

            // Sorties
            PWM Alarme = new PWM(PWMChannels.PWM_PIN_D5, 2000, 0.5, false); // Buzzer sur O4 Tinkerkit
            OutputPort CdeChauffage = new OutputPort(Pins.GPIO_PIN_D6, false); // Chauffage sur O3 Tinkerkit
            OutputPort CdeVentilation = new OutputPort(Pins.GPIO_PIN_D11, false); // Ventilation sur O0 Tinkerkit 
            ELCD162 Lcd = new ELCD162(); // Afficheur sur O5 Tinkerkit http://webge.github.io/ELCD162/ (Description de la classe ELCD162)

            Lcd.Init(); Lcd.ClearScreen(); Lcd.CursorOff();

            while (true)
            {
                // (3) A compléter
               
                
                Thread.Sleep(delayScrut); // Scrutation du clavier
            }

        }

    }
}
