using System;
using System.Threading;
using Microsoft.SPOT.Hardware;

using ToolBoxes;

namespace miniserrefinal
{
    public partial class Program
    {
        private static void Supervision(ref etats etat_1, ref etats etat, AnalogInput Thermometre, AnalogInput CaptHum, InputPort BTN1, PWM Alarme, OutputPort CdeChauffage, OutputPort CdeVentilation, ELCD162 Lcd)
        {
            // Constantes
            const UInt16 delayMes = 500;   // En ms
            const UInt16 TemperatureSeuilmin = 24;
            const UInt16 TemperatureConsigne = 26; // En C
            const UInt16 TemperatureSeuilmax = 28;
            const UInt16 HumiditeSeuil = 30; // En %

            //Variables
            var Temperature = 0.0;
            var Temperature_1 = 0.0;
            var Humidite = 0.0;
            var Humidite_1 = 0.0;
            var N1 = 0; // Sortie du CAN. Image de la temprature
            var N2 = 0; // Sortie du CAN. Image de l'humidit

            while (!BTN1.Read())                
            {
                // Lire
                N1 = Thermometre.ReadRaw(); Temperature = 0.02 * N1 - 25;
                N2 = CaptHum.ReadRaw(); Humidite = 0.026 * N2 - 25.8;

                if ((etat != etat_1) || (Humidite != Humidite_1) || (Temperature != Temperature_1))
                {
                    Lcd.ClearScreen();
                    Lcd.PutString("Superviser [1>R]");
                    Lcd.SetCursor(0, 1);
                    Lcd.PutString("T=" + Temperature.ToString("F0") + "degC " + "H=" + Humidite.ToString("F0") + "%");
                    etat_1 = etat; Temperature_1 = Temperature; Humidite_1 = Humidite;
                }

                if (Temperature > TemperatureConsigne)
                    CdeChauffage.Write(false);
                else
                    CdeChauffage.Write(true);

                if (Humidite < HumiditeSeuil)
                    CdeVentilation.Write(false);
                else
                    CdeVentilation.Write(true);

                if ((Temperature > TemperatureSeuilmin) && (Temperature < TemperatureSeuilmax))
                    Alarme.Stop();
                else
                    Alarme.Start();

                Thread.Sleep(delayMes); // Mesure toutes les  delayMes + delayScrut
            }
            etat = etats.Attendre;
        }
    }
}
